-- make defunct parts of everything that is marked as electric-pole

for k,v in pairs(data.raw["electric-pole"]) do
	local effectiveType = prototypes[v.name];
	
	if effectiveType then
		if effectiveType.makeVariations then	
			log("Modifying " .. v.name .. " to use as a " .. effectiveType.type)
				
			if effectiveType.type == "regularPole" then
				local modifiedPole = table.deepcopy(v);
				modifiedPole.name = modifiedPole.name .. "-disabled";
				modifiedPole.order = "z-z-z"
				modifiedPole.supply_area_distance = 0
				data:extend{modifiedPole}

				local modifiedRecipe = table.deepcopy(data.raw.recipe[v.name])
				modifiedRecipe.enabled = true
				modifiedRecipe.result = modifiedPole.name
			elseif effectiveType.type == "highPole" then
				v.supply_area_distance = 0
			end
		else
			log("Using " .. v.name .. " as a " .. effectiveType.type)
		end
	end
end
