data:extend({
{
	type = "item",
	name = "transformer",
	icon = "__highvoltage__/graphics/icons/transformer.png",
	flags = {"goes-to-quickbar"},
	subgroup = "energy-pipe-distribution",
	order = "a[energy]-d[transformer]",
	place_result = "transformer",
	stack_size = 50
},
{
    type = "electric-energy-interface",
    name = "transformer-interface-drain",
    icon = "__highvoltage__/graphics/icons/transformer.png",
    flags = {"placeable-neutral", "player-creation"},
    max_health = 999,
    corpse = "medium-remnants",
    collision_mask = {"ghost-layer"},
    collision_box = {{-0.9, -0.4}, {0.9, 0.4}},
    selection_box = {{-1, -0.5}, {1, 0.5}},
    energy_source =
    {
      type = "electric",
      buffer_capacity = "1MJ",
      usage_priority = "secondary-input",
      input_flow_limit = "999MW",
      output_flow_limit = "999MW"
    },
    picture = transparent_pic,
    order = "z",
},
{
    type = "electric-energy-interface",
    name = "transformer-interface-output",
    icon = "__highvoltage__/graphics/icons/transformer.png",
    flags = {"placeable-neutral", "player-creation"},
    max_health = 999,
    corpse = "medium-remnants",
    collision_mask = {"ghost-layer"},
    collision_box = {{-0.4, -0.9}, {0.4, 0.9}},
    selection_box = {{-0.5, -1}, {0.5, 1}},
    energy_source =
    {
      type = "electric",
      buffer_capacity = "1MJ",
      usage_priority = "secondary-output",
      input_flow_limit = "999MW",
      output_flow_limit = "999MW"
    },
    picture = transparent_pic,
    order = "z",
},
{
    type = "accumulator",
    name = "transformer",
    icon = "__highvoltage__/graphics/icons/transformer.png",
    flags = {"placeable-neutral", "player-creation"},
    minable = {hardness = 0.2, mining_time = 0.5, result = "transformer"},
    max_health = 150,
    corpse = "medium-remnants",
    collision_box = {{-0.9, -0.9}, {0.9, 0.9}},
    selection_box = {{-1, -1}, {1, 1}},
    energy_source =
    {
      type = "electric",
      buffer_capacity = "0.001MJ",
      usage_priority = "terciary",
      input_flow_limit = "1MW",
      output_flow_limit = "0.0kW"
    },
    picture =
    {
      filename = "__highvoltage__/graphics/entity/transformer/transformer.png",
      priority = "extra-high",
      width = 124,
      height = 103,
      shift = {0.6875, -0.203125}
    },
    charge_cooldown = 30,
    charge_light = {intensity = 0.1, size = 3, color = {r = 1.0, g = 1.0, b = 1.0}},
    discharge_cooldown = 60,
    discharge_light = {intensity = 0.1, size = 3, color = {r = 1.0, g = 1.0, b = 1.0}},
    vehicle_impact_sound =  { filename = "__base__/sound/car-metal-impact.ogg", volume = 0.65 },
    working_sound =
    {
      sound =
      {
        filename = "__base__/sound/accumulator-working.ogg",
        volume = .1
      },
      idle_sound = {
        filename = "__base__/sound/accumulator-idle.ogg",
        volume = 0.05
      },
      max_sounds_per_type = 5
    },
    circuit_wire_connection_point =
    {
      shadow =
      {
        red = {0.984375, 1.10938},
        green = {0.890625, 1.10938}
      },
      wire =
      {
        red = {0.6875, 0.59375},
        green = {0.6875, 0.71875}
      }
    },
    circuit_connector_sprites = get_circuit_connector_sprites({0.46875, 0.5}, {0.46875, 0.8125}, 26),
    circuit_wire_max_distance = 2.5,
    default_output_signal = {type = "virtual", name = "signal-A"}
},
{
    type = "recipe",
    name = "transformer",
    ingredients =
    {
      {"iron-plate", 5},
      {"electronic-circuit", 10},
      {"copper-cable", 15}
    },
    result = "transformer",
	enabled = true,
    energy_required = 2
},
})